package commons.pfc;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;

import javax.security.auth.login.LoginException;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.ComponentName;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

public class AndromediacommonsActivity extends Activity {
	
    /** Se llama cuando se crea la interfaz */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.layout_portada);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);//No girar pantalla
        
        inicializar();
    }
    /**
     * Objeto de la Clase wiki para trabaja con la API de wikimedia commons
     */
    public static API_Wiki usuario = new API_Wiki("commons.wikimedia.org"); 
    public static datos datos = new datos();
    public static ArrayList<datos_imagen_wiki_love> lista_imagenes = new ArrayList<datos_imagen_wiki_love>();
    public static ArrayList<String> datos_imagenes_rafaga = new ArrayList<String>();
    public static String texto_informativo="";
    public static String user, pass;
    //public static mapa_monumentos chapuza = new mapa_monumentos();
    
    public static datos_imagen_wiki_love datos_monumento = null;
   
    public static monumentsDB database;
    public static ArrayList<datos> datos_monumentos_bd = new ArrayList<datos>();

	Button btlogin;
	private ProgressDialog progressBarlogin;
	private int progressBarStatus = 0;
    
    private void inicializar() 
	 {
    	btlogin = (Button) findViewById(R.id.btloggin);
    	btlogin.setOnClickListener(
	                 new OnClickListener() 
	                 {
						   @Override
						   public void onClick(View v) 
						   {
							   //String que contiene el texto a mostrar en el progressbar
							   String texto = getString(R.string.txt_progressbar_portada);
								// preparando el cuadro de dialogo
							   progressBarlogin = new ProgressDialog(v.getContext());
							   progressBarlogin.setCancelable(true);
							   progressBarlogin.setMessage(texto + "...");
							   progressBarlogin.setProgressStyle(ProgressDialog.STYLE_SPINNER);
							   progressBarlogin.setProgress(0);
							   progressBarlogin.setMax(100);
							   progressBarlogin.show();
								progressBarStatus = 0;//cuadro de dialogo a 0
								
								new Thread(new Runnable() 
								{
								  @Override
								public void run() 
								  {
									while (progressBarStatus < 100) 
									{			 
										// Empieza la tarea en segundo plano.
										try { progressBarStatus = Click_Acceder(); }
										catch (LoginException e1) {// TODO Auto-generated catch block
											e1.printStackTrace(); }
										catch (IOException e1) {// TODO Auto-generated catch block
										e1.printStackTrace(); } catch (Exception e) {
											// TODO Auto-generated catch block
											e.printStackTrace();
										}
									}
									// Imagen subida
									if (progressBarStatus >= 100) 
										progressBarlogin.dismiss();
								  }
								}).start();
						  }
	 
	                 });
	 }
	 
    
    
    
    /**
     * Evalua si existen las credenicales, si existe, las lee y te logea automticamente. En caso contrario, crea un inten que es
 	 * el encargado de iniciar la nueva actividad. 
     * @param botton click En boton para logearse automticamente o manualmente, en funcin de la vez que se utiliza.
     */
    private int Click_Acceder()throws Exception
    {
    	boolean opcion=Existen_Credenciales();
    	Intent intent = new Intent();
    	if(opcion)
    	{ 

   	 		//String url = "https://toolserver.org/~erfgoed/api/api.php?action=search&srcountry=es&format=xml&limit=100000";
    		//usuario.love(url);
    		
    		datos.credenciales = Leer_Credenciales();
    		
    		user = datos.credenciales[0];
    		pass= datos.credenciales[1];
    		usuario.login(datos.credenciales[0], datos.credenciales[1].toCharArray());
    		intent.setComponent(new ComponentName(this, modo_captura.class));
    		progressBarlogin.dismiss();
    		finish();
    		startActivity(intent);
        }
    	else
    	{
        	intent.setComponent(new ComponentName(this, login.class));
        	progressBarlogin.dismiss();
        	finish();//mato el layout
        	startActivity(intent);
    	}
    	return 100;
    }
    
    public void Click_Informacion(View botton)
    {
    	Intent intent = new Intent();
    	intent.setComponent(new ComponentName(this, menu_informacion.class));
    	startActivity(intent);
    }
    
    /**
     * Lee las credenciales del archivo donde estaban almacenadas.
     * @return Devuelve un array de string con el usuario y la contrasea.
     */
    public String[] Leer_Credenciales()throws Exception
    {
    	String texto = "";
    	try
    	{
    	    BufferedReader fichero =
    	        new BufferedReader(
    	            new InputStreamReader(
    	                openFileInput("credenciales_commons")));
    	    
    	    texto = fichero.readLine();
    	    fichero.close();
    	}
    	catch (Exception ex)
    	{
    	    Log.e("Ficheros", "Error al leer fichero desde memoria interna");
    	}
    	return texto.split(",");
    }
    
    /**
     * Evalua si existe credenciales en el fichero de credenciales de la aplicacin.
     * @return false y no existen credenciales y true si las credenciales existen.
     * @throws IOException 
     */
    private boolean Existen_Credenciales()throws Exception
    {
    	String texto=null;
    	try
    	{
    	    BufferedReader fichero =
    	        new BufferedReader(
    	            new InputStreamReader(
    	                openFileInput("credenciales_commons")));
    	    texto = fichero.readLine();
    	    fichero.close();
    	    if(texto==null)
    	    	return false;
    	    else 
    	    	return true;
    	}
    	catch (Exception ex)
    	{
    	    return false;
    	}
    }
    
    
    @Override
    public void onBackPressed() {
    	Intent intent = new Intent();
        intent.setAction(Intent.ACTION_MAIN);
        intent.addCategory(Intent.CATEGORY_HOME);

        startActivity(intent);

    return;

    }

}



