package commons.pfc;

import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class obtener_coordenadas extends AndromediacommonsActivity {
	protected static final String LOG_TAG = null;

		/** Called when the activity is first created. */
	    @Override
	    public void onCreate(Bundle savedInstanceState) 
	    {
	        super.onCreate(savedInstanceState);
	        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);//No girar pantalla
	        setContentView(R.layout.layout_obtener_coordenadas);
	        inicializar();
	    } 
	    
	    private LocationManager locMgr;
	    private LocationListener onLocationChange;
	    
	    private TextView lon;
	    private TextView lat;
	    private TextView alt;
	    private Button bttriangulacion;
	    private Button btgps;
	    private Button bt_sig;
	    public android.location.Location location;
	    
	    private void inicializar()
	    {

	    	lon = (TextView)findViewById(R.id.longitud);
	    	lat = (TextView)findViewById(R.id.latitud);
	    	alt = (TextView)findViewById(R.id.altitud);
	    	bttriangulacion = (Button) findViewById(R.id.boton_tri);
	    	btgps = (Button) findViewById(R.id.boton_gps);
	    	locMgr = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
	    	
	    	onLocationChange = new LocationListener() 
	    	{
		    	@Override
		    	public void onLocationChanged(android.location.Location location) 
		    	{
		    		lon.setText("" + location.getLongitude());
		    		lat.setText("" + location.getLatitude());
		    		alt.setText("" + location.getAltitude());
		    		datos.longitud = lon.getText().toString();
		    		datos.altitud = alt.getText().toString();
		    		datos.latitud = lat.getText().toString();
		    		bt_sig = (Button) findViewById(R.id.button1);
		    		bt_sig.setVisibility(1);
		    	}
		    	
		    	@Override
		    	public void onProviderDisabled(String provider) 
		    	{
		    		Log.i(LOG_TAG, "Location provider " + provider + " has been disabled.");
		    	}
		    	
		    	@Override
		    	public void onProviderEnabled(String provider) 
		    	{
		    		Log.i(LOG_TAG, "Location provider " + provider + " has been enabled.");
		    	}
		    	
		    	@Override
		    	public void onStatusChanged(String provider, int status, Bundle extras) 
		    	{
		    		Log.i(LOG_TAG, "Location provider " + provider + " has changed status to " + status);
		    	}
	    	};
	    	
	    	bttriangulacion.setOnClickListener(new View.OnClickListener() {
				
				@Override
				public void onClick(View v) {
					// TODO Auto-generated method stub
			    		locMgr.requestLocationUpdates(LocationManager.NETWORK_PROVIDER, 1, 1, onLocationChange);
			    		location = locMgr.getLastKnownLocation(LocationManager.NETWORK_PROVIDER);
			    }
			});
		    
	    	
	    	btgps.setOnClickListener(new View.OnClickListener() {
				
				@Override
				public void onClick(View v) {
					// TODO Auto-generated method stub
		    		locMgr.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0, onLocationChange);
		    		location = locMgr.getLastKnownLocation(LocationManager.GPS_PROVIDER);
				}
			});
	    	
	    	if (location == null)
	    		location = locMgr.getLastKnownLocation(LocationManager.NETWORK_PROVIDER);
	    	
	    	if (location != null) 
	    	{
	    		lon.setText("Buscando...");
	    		lat.setText("Buscando...");
	    		alt.setText("Buscando...");	
	    	}
	    	else 
	    	{
	    		lon.setText("No disponible");
	    		lat.setText("No disponible");
	    		alt.setText("No disponible");
	    		
	    		datos.longitud = lon.getText().toString();
	    		datos.altitud = alt.getText().toString();
	    		datos.latitud = lat.getText().toString();
	    		
	    	}    
	    }
	    
	    public void Click_Siguiente(View botton)
	    {
	    	locMgr.removeUpdates(onLocationChange);
	    	Intent intent = new Intent();
	    	if((!datos.wikimonuments && !datos.mapa && !monumentsDB.bd))
	    		intent.setComponent(new ComponentName(this, subir.class));
	    	else
	    	{
	    		if(monumentsDB.bd)
	    		intent.setComponent(new ComponentName(this, mapa_monumentos_DB.class));
	    		else
	    		{
	    			if(datos.wikimonuments && datos.distancia_seleccionada)
	    				intent.setComponent(new ComponentName(this, subir.class));
	    			else
	    			intent.setComponent(new ComponentName(this, seleccion_distancia_monumentos.class));
	    		}
	    	}
			startActivity(intent);
	    }
	    
	    @Override
	    public void onBackPressed()
	    {
			Intent intent = new Intent();
			monumentsDB.bd = false;
			datos.ReiniciarDatos();
			intent.setComponent(new ComponentName(this, modo_captura.class));
			startActivity(intent);
	    }
	}